/*
 * DSGatewayR2.c
 *
 * Created: 2014/01/25 14:23:53
 *  Author: Administrator
 */ 

#include "DS_Type.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "DS_Common.h"
#include "DS_DCC.h"
#include "DS_MM2.h"
#include "DS_List.h"


#define SIZE_PACKET 8
#define PACKET_NOTRECEIVED 0
#define PACKET_RECEIVED 1


UC gPacketMode; /**< [h */
UC gReceivePacket[10];
UC gSendPacket[10];
UC gPacketCount = 0;
UC gPacketReceived = PACKET_NOTRECEIVED;
DS_ITEM gList[ITEM_LISTSIZE];/**< MǗpXg */

UC gScanIndex = 0;
UC gExtendMode = 0; /**< g[h(DCC,MM2)̗p`FbN  */

UC gPoweronTrigger = TRIGGER_NONE;

void init();
void SPI_Init();

void Main_sendReplyPacket(UC inReplyCommand);
UC Main_decodeMain(UC *inPackets);
void Main_RunCVWrite( US inAddress, UC inCVValue);
UC Main_decodeLocDirection(DS_ITEM *inList, US address, UC direction, UC *outType, UC *outPackets, UC *outLen);
void Main_decodeLocFunction(DS_ITEM *inList, US address, UC function, UC power, UC *outType, UC *outPackets, UC *outLen, UL *ioFuncBuf);
void Main_decodeAccessory(US address, UC power, UC *outType, UC *outPackets, UC *outLen);
void Main_decodeLocSpeed(DS_ITEM *inList, US address, SS speed, UC *outType, UC *outPackets, UC *outLen, UC inSpeedStep);
void Main_decodeAddress( US address, UC *outpType, UC *outpAddr1, UC *outpAddr2, UC *outpLen);
void Main_decodeExtendCommand(UC inExCommand, UC inLen, UC *inData);
void Main_registerDCCPoweronSequence();

void TIMER2_stop(void);
void TIMER2_start(void);
US TIMER2_getcnt(void);


UC MAIN_scanList(DS_ITEM *inList, UC inScanIndex)
{
	UC aRetIndex = inScanIndex;
	UC aMM2_Len;
	
	if( inScanIndex >= ITEM_LISTSIZE)
	{
		return 255;
	}
	
	/* pPbg𑗐M */
	if( inList[inScanIndex].mType == ITEMTYPE_MM2BASE )
	{
		/* ÕpPbgƋʂ邽߂ɃEFCg */
		_delay_ms(6);

		/* gt@NVǂ`FbN */
		if(inList[inScanIndex].mFuncNo > 5 )
		{
			/* gt@NVM(F5-F16)𑗂BDouble Packet x3 (6)PʁBx̓[B */
			MM2_SendDoublePackets(inList[inScanIndex].mDatas, 3, MODEMM2_BASE, inList[inScanIndex].mFuncNo, inList[inScanIndex].mFunctionBuf);
			MM2_WaitLong();
			MM2_SendDoublePackets(inList[inScanIndex].mDatas, 3, MODEMM2_BASE, inList[inScanIndex].mFuncNo, inList[inScanIndex].mFunctionBuf);
			MM2_WaitLong();
			MM2_SendDoublePackets(inList[inScanIndex].mDatas, 3, MODEMM2_BASE, inList[inScanIndex].mFuncNo, inList[inScanIndex].mFunctionBuf);
			
		}
		else
		{
			/* xM̂ݑ(2x double packet) */
			MM2_SendDoublePackets(inList[inScanIndex].mDatas, 3, MODEMM2_BASE, 0, inList[inScanIndex].mFunctionBuf);
			MM2_WaitLong();
			MM2_SendDoublePackets(inList[inScanIndex].mDatas, 3, MODEMM2_BASE, 0, inList[inScanIndex].mFunctionBuf);

			if((inList[inScanIndex].mLen > 3) || (inList[inScanIndex].mFuncNo > 0) )
			{
				aMM2_Len = inList[inScanIndex].mLen > 3 ? 4 : 3;
			
				/* 50ms҂ */
				_delay_ms(50);
				
				/* t@NVMA28StepMAt@NV28StepM𑗂 */
				MM2_SendDoublePackets(inList[inScanIndex].mDatas, aMM2_Len, MODEMM2_BASE, inList[inScanIndex].mFuncNo, inList[inScanIndex].mFunctionBuf);
				MM2_WaitLong();
				MM2_SendDoublePackets(inList[inScanIndex].mDatas, aMM2_Len, MODEMM2_BASE, inList[inScanIndex].mFuncNo, inList[inScanIndex].mFunctionBuf);
		
			}
		
		}
				
		/* JE^fNg */
		if( inList[inScanIndex].mFuncCounter > 0)
		{
			inList[inScanIndex].mFuncCounter--;
		}
		
		/* t@NVo͂~ */
		if((inList[inScanIndex].mFuncCounter == 0) && (inList[inScanIndex].mFuncNo > 0))
		{
			inList[inScanIndex].mFuncNo = 0;
		}
				
						
	}
	else if( inList[inScanIndex].mType == ITEMTYPE_MM2HALF )
	{
		/* ÕpPbgƋʂ邽߂ɃEFCg */
		_delay_ms(6);

		/* ڂ́AMi\mChւ̗㎥j*/
		if( inList[inScanIndex].mCnt <= 1 )
		{
			inList[inScanIndex].mDatas[2] = 0x00;
		}
		
		/* v8pPbg(_upPbgx4)𑗂BԊu762usA1.5msB */
		for( int i = 0; i < 4; i++)
		{
			MM2_SendPackets(inList[inScanIndex].mDatas, 3, MODEMM2_HALF, 0, 0);
			_delay_us(762);
			MM2_SendPackets(inList[inScanIndex].mDatas, 3, MODEMM2_HALF, 0, 0);
			_delay_us(1500);			
		}
		
	}	
	else if( inList[inScanIndex].mType == ITEMTYPE_DCC )
	{
		
		DCC_SendPackets(inList[inScanIndex].mDatas, inList[inScanIndex].mLen);
		
		/* 񐔐̂pPbg͓񑗂 */
		if( inList[inScanIndex].mCnt > 0)
		{
			DCC_SendPackets(inList[inScanIndex].mDatas, inList[inScanIndex].mLen);
		}		
	}
	
	else if( inList[inScanIndex].mType == ITEMTYPE_UNKNOWN )
	{
		aRetIndex = 255;
	}	
	
	else
	{
		aRetIndex = 255;
	}	
		
	/* JEglĂw߂͎Ԃ폜 */
	if( (inList[inScanIndex].mCnt > 0) & (aRetIndex != 255))
	{
		inList[inScanIndex].mCnt--;
		if( inList[inScanIndex].mCnt <= 0)
		{
			DSList_DeleteItem(inList, inScanIndex);
		}	
	}	
	
	return aRetIndex;
}




UC Main_decodeMain(UC *inPackets)
{
	UC aInLen;
	UC aLen;
	UC aType;
	UC aPackets[5] = {0,0,0,0,0};
	US aAddress;
	SS aSpeed;
	UC aFunction;
	UC aPower;
	UC aDirection;
	UC aCRC;
	UL aFuncBuf = 0;
	UC aCVValue;
	UC aProtocol = 0;
	
	/* TCY̎擾 */
	aInLen = inPackets[0] & 0b1111;
	
	/* TCY`FbN */
	if( aInLen <= 1)
	{
		/* CMD ERR */
		return 0xFE;
	}
	
	/* pPbg`FbN */
	aCRC = DS_CalculateCRC(inPackets, aInLen);
	
	if( aCRC != inPackets[aInLen - 1])
	{
		/* CRCG[*/		
		//return 0xFF;
	}	

	/* R}hƂɏ */
	
	switch(inPackets[0] & 0b11110000)
	{
	case CMD_PWR_OFF:
		DS_Power(0);
		gPoweronTrigger = TRIGGER_NONE;		
		break;
	
	case CMD_PWR_ON:
		/* Hɓd */
		DS_Power(1);
		
		/* ً}~{^Lp */
		gPoweronTrigger = TRIGGER_SPI;	
		
		/* fR[_̓d肷܂ő҂ */
		_delay_ms(10);
		
		/* g[h̗L */
		if( aInLen >= 3)
		{
			/* (2)NotDCC/DCC (1) \A(0)\ */
			gExtendMode = inPackets[1];
		}		
		
		/* XgNA */
		//DSList_Clear(gList);
		
	
		if( (gExtendMode & 0b100) == 0)
		{
			 Main_registerDCCPoweronSequence();		
		}
		else
		{
			/* MM2AChpPbg */
		}			
						
		break;	
			
	case CMD_SPEED:
		
		/* f[^擾 */
		aAddress = (inPackets[2] << 8) + inPackets[1];
		aSpeed = (inPackets[4] << 8) + inPackets[3];
		
		if( aInLen >= 7)
		{
			/* SpeedStep̃Zbg */
			aProtocol = inPackets[5];
		}
		else
		{
			/* ftHgiDCC 28, MM2 14j̎gp(Ȃ) */
			aProtocol = 0xFF;
		}
		
		/* AhXfR[h */
		Main_decodeLocSpeed(gList, aAddress, aSpeed, &aType, aPackets, &aLen, aProtocol);
		
		/* ǗXgAbvf[g */
		DSList_UpdateItem(gList, aType, CMD_SPEED, aLen, 0, aPackets);
		
		break;
		
	case CMD_ACCESSORY:
		aAddress = (inPackets[2] << 8) + inPackets[1];
		//inPackets[3];͖gpBiPosition̗\񂾂AgȂƂɂȂĂ܂B)
		aPower = inPackets[4];
		
		/* ANZTw߃fR[h */
		Main_decodeAccessory(aAddress, aPower, &aType, aPackets, &aLen);

		/* ǗXgAbvf[g */
		DSList_UpdateItem(gList, aType, CMD_ACCESSORY, aLen, 2, aPackets);		
		break;
		
	case CMD_FUNCTION:
		aAddress = (inPackets[2] << 8) + inPackets[1];
		aFunction = inPackets[3];
		aPower = inPackets[4];
		
		/* t@NVw߃fR[h */
		Main_decodeLocFunction(gList, aAddress, aFunction, aPower, &aType, aPackets, &aLen, &aFuncBuf);

		/* t@NV߂͏㏑(MM2p, DCC͒ʏ̃Abvf[g) */
		DSList_UpdateItem_OWFunction(gList, aType, CMD_FUNCTION, aLen, aFuncBuf, aFunction, aPackets);	
			
		break;
		
	case CMD_DIRECTION:
		/* f[^擾 */
		aAddress = (inPackets[2] << 8) + inPackets[1];
		
		aDirection =  inPackets[3];// FWD:0 REV:1
		
		/* AhXfR[h,XgƎw߂قȂꍇ͒~ */
		switch( Main_decodeLocDirection(gList, aAddress, aDirection, &aType, aPackets, &aLen) )
		{
			case 1:
				/* x[ɂĎ~߂ */
				Main_decodeLocSpeed(gList, aAddress, 0, &aType, aPackets, &aLen, 0xFF);
				DSList_UpdateItem(gList, aType, CMD_SPEED, aLen, 0, aPackets);
				break;
			
			case 255:
				/* VKo^ */
				Main_decodeLocSpeed(gList, aAddress, 0, &aType, aPackets, &aLen, 0xFF);
				/* o^XgɓĂȂ̂́AXgɐVKo^iisi[邽߁j */
				DSList_NewItem(gList, aType, CMD_SPEED, aLen, 0, aDirection, aPackets);
				break;
			
			default:
				break;
		}

		break;
		
	case CMD_CVWRITE:
		/* CV */
		aAddress = ((inPackets[2] << 8) + inPackets[1]);
		aCVValue = inPackets[3];
		
		UC aPowerOnEnd = DS_IsPowerOn();

		/* dՒfidI͂dՒfj */
		DS_Power(0);
		_delay_ms(800);
			
		/* Hɓd */
		DS_Power(1);
			
		/* fR[_̓d肷܂ő҂(100msł邱ƁB) */
		_delay_ms(50);
			
		/* ŏʃrbgĂƂMM2, 0̏ꍇDCCƂ */
		/* 0b10xx MM2
		   0b00xx DCC (W)
		   0b01xx DCC (DS-DCCfR[_p, BootloaderN҂)
		  */
		
		
		if( (aAddress & 0x8000) > 0)
		{
			/* X҂ */
			_delay_ms(3);
			/*MM2*/
			aAddress = aAddress & 0x7FFF;
				
			for(int j = 0; j < 8; j++)
			{
				int aSendCount = 0;
					
				switch(j)
				{
					case 0:
					/* @֎ԃAhX120񑗂(㔼11) */
					aPackets[0] = 0b00000000;
					aPackets[1] = 0b00;
					aPackets[2] = 0b00000011;
					aSendCount = 120;
					break;
						
					case 1:
					/* @֎ԃAhX30񑗂(㔼00) */
					aPackets[2] = 0b00000000;
					aSendCount = 30;
					break;
						
					case 2:
					/* CV No𑗂(㔼00) */
					aPackets[0] = MM2_encodeAddress(aAddress);
					aPackets[2] = 0b00000000;
					break;
						
					case 3:
					/* CV No𑗂(㔼11) */
					aPackets[2] = 0b00000011;
					break;
					
					case 4:
					/* CV No𑗂(㔼00) */
					aPackets[2] = 0b00000000;
					break;					
						
					case 5:
					/* CV Value𑗂(㔼00) */
					aPackets[0] = MM2_encodeAddress(aCVValue);
					aPackets[2] = 0b00000000;
					break;
						
					case 6:
					/* CV Value𑗂(㔼11) */
					aPackets[2] = 0b00000011;
					break;
					
					case 7:
					/* CV Value𑗂(㔼00) */
					aPackets[2] = 0b00000000;
					aSendCount = 60;
					break;					
				}
					
				/* pPbg𑗂 */
				for( int i = 0; i < aSendCount; i++)
				{
					MM2_SendDoublePackets(aPackets, 3, MODEMM2_BASE, 0, 0);
					MM2_WaitLong();
				}
			}

		}
		else
		{
			
			/* DS-DCC DecoderpŃu[g[_̗オ(1sec)҂ */
			if(	(aAddress & 0x4000) > 0)
			{
				_delay_ms(3000);
				aAddress = aAddress & 0x3FFF;
			}
			
			/*DCC*/
			aAddress = aAddress - 1;/* 1-1023A0-1022ɕϊ */
				
			/* ZbgpX3ȏ㑗 */
			for( int i = 0; i < 10; i++)
			{
				DCC_SendInitialPacket();
				_delay_us(150);
			}
				
			/* CVpPbg(ݎw) */
			aPackets[0] = 0b01110000 | 0b00001100 | ((aAddress >> 8) & 0b11);
			aPackets[1] = aAddress & 0b11111111;
			aPackets[2] = aCVValue;
				
			/* CVw߂5ȏ㑗 */
			for( int i = 0; i < 10; i++)
			{
				DCC_SendPacketsEx(aPackets, 3, 24);
				_delay_us(150);
			}
				
			/* ZbgpX6ȏ㑗 */
			for( int i = 0; i < 12; i++)
			{
				DCC_SendInitialPacket();
				_delay_us(150);
			}

		}

		/* d؂ */
		DS_Power(0);

			
		/* dՒf(ŏdĂƂ́Â܂܃I) */
		if( aPowerOnEnd != 0)
		{
			_delay_ms(1000);
			DS_Power(1);
			_delay_ms(1);
		}
		
		break;	
		
	case CMD_EXTENTION:
		/* gR}h */
		Main_decodeExtendCommand(inPackets[1], aInLen, inPackets);	
	
	
		break;


	case CMD_OK:
	case CMD_WAIT:
		/* EFCg */	
	
		break;		
					
	default:
		/*R}hG[Ԃ*/
		return 0xFE;
		break;
	
	}
	
	return 0;
		
}

void Main_decodeExtendCommand(UC inExCommand, UC inLen, UC *inData)
{
	
	switch(inExCommand)
	{
		case EXCMD_NONE:
	
		break;
		
		
		
	}
	
	
}



void Main_sendReplyPacket(UC inReplyCommand)
 {	 
	 
	 gSendPacket[0] = inReplyCommand;
	 gPacketCount = 0;
	 
	 /* MpPbg */
	 for( int i = 1; i < 7; i++)
	 {
		 gSendPacket[i] = 0x00;
	 }
	 
 }
 
UC Main_decodeLocDirection(DS_ITEM *inList, US address, UC direction, UC *outType, UC *outPackets, UC *outLen)
{
	UC aAddr1, aAddr2;
	UC aLen;
	UC aType;
	UC aDirection;
	UC aIndex;
	
	/* decode loc address */
	Main_decodeAddress( address, &aType, &aAddr1, &aAddr2, &aLen);
	
	/* pPbg̃AhX͊m肷̂ŃZbg */
	outPackets[0] = aAddr1;
	
	if( aLen >= 2)
	{
		outPackets[1] = aAddr2;
	}
	
	*outType = aType;	
	
	/* Õt@NVf[^KvȂߓAhXT */
	aIndex = DSList_FindItem(inList, aType, aLen, 0, outPackets);
	
	if( aIndex != 255)
	{
		aDirection = inList[aIndex].mDirection;
	}
	else
	{
		return 255;
	}
	
	if( aDirection != direction)
	{
		/* قȂꍇ̓Xg */
		inList[aIndex].mDirection = direction;
		return 1;		
	}
	else
	{
		/* ꍇ͏KvȂ */
		return 0;
	}
	
}
 
void Main_decodeLocFunction(DS_ITEM *inList, US address, UC function, UC power, UC *outType, UC *outPackets, UC *outLen, UL *ioFuncBuf)
{
	UC aAddr1, aAddr2;
	UC aLen;
	UC aType;
	UL aFunctionBuf;
	UC aIndex;
	UC aOffset;

	/* decode loc address */
	Main_decodeAddress( address, &aType, &aAddr1, &aAddr2, &aLen);
	
	/* pPbg̃AhX͊m肷̂ŃZbg */
	*outType = aType;	
	outPackets[0] = aAddr1;
	
	if( aLen >= 2)
	{
		outPackets[1] = aAddr2;
	}
				
	/* Õt@NVf[^KvȂߓAhXT */
	aIndex = DSList_FindItem(inList, aType, aLen, 0, outPackets);
	
	if( aIndex != 255)
	{
		aFunctionBuf = inList[aIndex].mFunctionBuf;
	}
	else
	{
		aFunctionBuf = 0;
	}				
				
	
	/* decode function  */
	
	switch( aType)
	{
		case ITEMTYPE_MM2BASE:
			outPackets[1] = 0b00;
			outPackets[2] = 0x00;/* _~[ */
			outPackets[3] = 0x00;
			
			/* 4oCgڂɃt@NVLڂĂ */
			if( power == 0)
			{
				*ioFuncBuf = aFunctionBuf & (~(1UL << (function - 1)));
			}
			else
			{
				*ioFuncBuf = aFunctionBuf | (1UL << (function - 1));
			}
			*outLen = 3;	

		break;
		
		case ITEMTYPE_DCC:
		
			aOffset = ( aLen >= 2) ? 1 : 0;

			/*@t@NV̏DCC̃pPbg@*/
			outPackets[1 + aOffset] = DCC_decodeFunction(function, power, &aFunctionBuf);
				
			/* F13-F20, F21-28̊gt@NVpit@NVpɃTCYj */
			switch(outPackets[1 + aOffset])
			{
				case 0b11011110:
				outPackets[2 + aOffset] = ((aFunctionBuf >> 13) & 0xFF);
				*outLen = 3 + aOffset;
				break;
					
				case 0b11011111:
				outPackets[2 + aOffset] = ((aFunctionBuf >> 21) & 0xFF);
				*outLen = 3 + aOffset;
				break;
					
				default:
				*outLen = 2 + aOffset;
				break;
			}
			
			*ioFuncBuf = aFunctionBuf;
		
		
		break;
	}	
	
}

void Main_decodeLocSpeed(DS_ITEM *inList, US address, SS speed, UC *outType, UC *outPackets, UC *outLen, UC inSpeedStep)
{
	UC aAddr1, aAddr2;
	UC aLen;
	UC aType;
	UC aDirection;
	UC aIndex;
	UC aSpeed;
	UC aOffset;

	/* decode loc address */
	Main_decodeAddress( address, &aType, &aAddr1, &aAddr2, &aLen);
	
	/* pPbg̃AhX͊m肷̂ŃZbg */
	*outType = aType;
	outPackets[0] = aAddr1;
	
	if( aLen >= 2)
	{
		outPackets[1] = aAddr2;
	}	
	
	/* Õt@NVf[^KvȂߓAhXT */
	aIndex = DSList_FindItem(inList, aType, aLen, 0, outPackets);
	
	if( aIndex != 255)
	{
		aDirection = inList[aIndex].mDirection;
	}
	else
	{
		aDirection = 0;
	}
		
	/* Speedstep̃Zbg */
	if( inSpeedStep != 0xFF)
	{
		inList[aIndex].mSpeedStep = inSpeedStep;
	}	
	
	/* decode speed  */
	
	switch( aType)
	{
	case ITEMTYPE_MM2BASE:
		outPackets[1] = 0b00;
		
		if(inList[aIndex].mSpeedStep == SPEEDSTEP_MM14)
		{
			/* 14 step speed */			
			aSpeed = DS_CalcSpeedStep(speed, 14);
			outPackets[2] = MM2_encodeSpeed14Step(aSpeed, aDirection);
			*outLen = 3;
		}
		else if(inList[aIndex].mSpeedStep == SPEEDSTEP_MM28)
		{
			/* 28 step speed */		
			UC aRawSpeed = DS_CalcSpeedStep(speed, 28);
			UC aSecondSpeed = aRawSpeed >> 1;
			
			if( aRawSpeed > (aSecondSpeed << 1))
			{
				aSpeed = aSecondSpeed + 1;
			}
			else
			{
				if( aRawSpeed > 0)
				{
					aSpeed = aSecondSpeed - 1;
				}
				else
				{
					aSpeed = 0;
				}
			}
			
			outPackets[2] = MM2_encodeSpeed14Step(aSpeed, aDirection);
			outPackets[3] = MM2_encodeSpeed14Step(aSecondSpeed, aDirection);			
			*outLen = 4;
		}
		else
		{
			outPackets[2] = 0;
			*outLen = 3;			
		}			
					
				
		break;
		
	case ITEMTYPE_DCC:
		
		aOffset = (aLen >= 2) ? 1: 0;
					
		if(inList[aIndex].mSpeedStep == SPEEDSTEP_DCC28)
		{
			/* 28stepx */
			outPackets[1 + aOffset] = DCC_decodeSpeedStep28(speed, aDirection);
			*outLen = 2 + aOffset;
		}
		else if(inList[aIndex].mSpeedStep == SPEEDSTEP_DCC127)
		{
			/* g127stepx */
			outPackets[1 + aOffset] = 0b00111111;
			outPackets[2 + aOffset] = DCC_decodeSpeedStep127(speed, aDirection);
			*outLen = 3 + aOffset;
		}
		else if(inList[aIndex].mSpeedStep == SPEEDSTEP_DCC14)
		{
			/* 14stepx */
			outPackets[1 + aOffset] = DCC_decodeSpeedStep14(speed, aDirection, (UC)(inList[aIndex].mFunctionBuf & 0b1));
			*outLen = 2 + aOffset;
		}
		else
		{
			outPackets[1 + aOffset] = 0;
			*outLen = 2 + aOffset;
		}
		
		break;
	}
	

}

void Main_decodeAccessory(US address, UC power, UC *outType, UC *outPackets, UC *outLen)
{
	UC aAddr1, aAddr2;
	UC aLen;
	UC aType;
	UC aPower;
	UC aProtocolType = DS_GetLocIDProtocol((UC)(address >> 8));
	
	/* decode position  */
	
	switch( aProtocolType)
	{
	case PROTOCOL_DCC_ACC:
		/* decode acc address (basic 9bit accessory mode) */
		Main_decodeAddress( address, &aType, &aAddr1, &aAddr2, &aLen);
		
		/* Power: 0 Straight(Green), 1 Diverging(Red) */
			
		*outType = ITEMTYPE_DCC;
		outPackets[0] = aAddr1;
		outPackets[1] = aAddr2 | 0b1000 | (power & 0b1) | ((((address - ADDR_ACC_DCC) % 4) & 0b11)  << 1);//1AAACDDD
		*outLen = 2;
	
		break;
		
	case PROTOCOL_MM2_ACC:
		/* decode acc address */
		Main_decodeAddress( address, &aType, &aAddr1, &aAddr2, &aLen);
		
		if( power > 0)
		{
			/* RED(1) */
			aPower = 0b11000000; //8,7bitڂActiveM
		}
		else
		{
			/* GREEN(0) */
			aPower = 0b11000011; //8,7bitڂActiveM
		}
		
		*outType = ITEMTYPE_MM2HALF;
		outPackets[0] = aAddr1;
		outPackets[1] = 0b00;
		outPackets[2] = MM2_encodeAccSecondAddress((address - 0x3000) % 4) | aPower;
		*outLen = 3;
		break;
	}
	

}


void Main_decodeAddress( US address, UC *outpType, UC *outpAddr1, UC *outpAddr2, UC *outpLen)
{
	US aTempAddr;
	UC aType = DS_GetLocIDProtocol((UC)(address >> 8));
	
	switch(aType)
	{
		case PROTOCOL_MM2:
			aTempAddr = address;
			
			if( aTempAddr <= 256)
			{
				*outpType = ITEMTYPE_MM2BASE;
				*outpAddr1 = MM2_encodeAddress(aTempAddr);
				*outpAddr2 = 0;
				*outpLen = 1;
			}
			else
			{
				*outpLen = 0;
			}
			break;

		case PROTOCOL_MM2_ACC:
			
			aTempAddr = ((address - 0x3000) >> 2) + 1;
			
			if( aTempAddr <= 80)
			{
				*outpType = ITEMTYPE_MM2HALF;
				*outpAddr1 = MM2_encodeAddress(aTempAddr);
				*outpAddr2 = 0;
				*outpLen = 1;
			}
			else
			{
				*outpLen = 0;
			}
			break;

		case PROTOCOL_DCC:
			*outpType = ITEMTYPE_DCC;
			
			/* offset DCC address to convert CAN address to DCC address */
			aTempAddr = address - 0xC000;

			if( aTempAddr <= 127)
			{
				/* 0-127 address */
				*outpAddr1 = (UC)(aTempAddr & 0b01111111);
				*outpAddr2 = 0;
				*outpLen = 1;
			}
			else if( aTempAddr < 10239)
			{
				/* DCC 14bit address range is 0b11000000-0b00000000(49152, addr.0) to 0b11100111-0b11111111(59391) */
				/* 128-10239 address, but 0-127 long address doesn't use */
				aTempAddr = aTempAddr + 49152;
				*outpAddr1 = (UC)((aTempAddr >> 8) & 0xFF);
				*outpAddr2 = (UC)(aTempAddr & 0xFF);
				*outpLen = 2;
			}
			else
			{
				/* out of 9bit/14bit locomotive address range */
				*outpLen = 0;
				
			}
			
			break;

		case PROTOCOL_DCC_ACC:
			*outpType = ITEMTYPE_DCC;
			
			/* offset DCC address to convert CAN address to DCC address */
			aTempAddr = ((address - ADDR_ACC_DCC) >> 2) + 1;
			
			if( aTempAddr < 512)
			{
				*outpAddr1 = (UC)(0b10000000 | (aTempAddr & 0b00111111));//10AAAAAA 
				*outpAddr2 = (UC)(0b10000000 | ((((~aTempAddr) & 0b111000000) >> 2) & 0xFF));//1AAACDDD
				*outpLen = 2;
			}
			else
			{
				/* out of 9bit accessory address range */
				//Extended Accessory Decoder Control Packet Format
				*outpLen = 0;
				
			}
			
			break;
		default:
			*outpLen = 0;
			break;
	}

}



void Main_registerDCCPoweronSequence()
{
	//ACeo^p
	DS_ITEM aItem;	
	
	/* SDCCfR[_Zbg */
	DCC_SendInitialPacket();
				
	/* DCCdlA20msȏ҂Bݒ胂[hɈڍsȂ߁B */
	_delay_ms(21);

	/* DCC Idle */
	aItem.mType = ITEMTYPE_DCC;
	aItem.mCmd = CMD_PWR_ON;
	aItem.mLen = 2;
	aItem.mCnt = 0;
	aItem.mDatas[0] = 0b11111111;
	aItem.mDatas[1] = 0b00000000;
	
	DSList_AddItem(gList, aItem);
}


int main(void)
{

	init();
	
	/* ݋ */
	sei();
	
	/*  */
	DCC_Init();
	
	/* XgXL */
	gScanIndex = 0;
	DSList_Clear(gList);	
	
	/* DEBUG */
	/*
	DS_Power(1);
	_delay_ms(100);
	DCC_PoweronSequence();
	*/
	
	/* pPbgL */
	Main_sendReplyPacket(CMD_WAIT);
	
	/* DEBUG */
	
	/*
	gReceivePacket[0] = CMD_PWR_ON | 1;
	gReceivePacket[1] = gReceivePacket[0];
	gReceivePacket[2] = 0;
	gReceivePacket[3] = 0;
	gReceivePacket[4] = 0;
	gPacketReceived = PACKET_RECEIVED;
	*/
	
	/*
	gReceivePacket[0] = CMD_ACCESSORY | 5;
	gReceivePacket[1] = (ADDR_ACC_MM2 + 10) & 0xFF;//address (low)
	gReceivePacket[2] = ((ADDR_ACC_MM2 + 10) >> 8) & 0xFF;//address (high)
	gReceivePacket[3] = 0x00;//position
	gReceivePacket[4] = 0x00;//power
	gPacketReceived = PACKET_RECEIVED;
	*/
	
	/*
	gReceivePacket[0] = CMD_SPEED | 5;
	gReceivePacket[1] = (ADDR_MM2 + 3) & 0xFF;//address (low)
	gReceivePacket[2] = ((ADDR_MM2 + 3) >> 8) & 0xFF;//address (high)
	gReceivePacket[3] = 0x30;//speed(low)
	gReceivePacket[4] = 0xFF;//speed(high)
	gPacketReceived = PACKET_RECEIVED;
		*/
	/*
	gReceivePacket[0] = CMD_FUNCTION | 5;
	gReceivePacket[1] = (ADDR_DCC + 200) & 0xFF;//address (low)
	gReceivePacket[2] = ((ADDR_DCC + 200) >> 8) & 0xFF;//address (high)
	gReceivePacket[3] = 29;//function
	gReceivePacket[4] = 1;//power
	gPacketReceived = PACKET_RECEIVED;
	*/
	
	/*
	gReceivePacket[0] = CMD_CVWRITE | 5;
	gReceivePacket[1] = 1;//CV No (low)
	gReceivePacket[2] = 0;//CV No (high)
	gReceivePacket[3] = 5;//CV Value
	gReceivePacket[4] = 0;//CRC
	gPacketReceived = PACKET_RECEIVED;
	*/		
	

	/* EFCg */
	_delay_ms(30);
	
    while(1)
    {
	
		/* MmF */
		if( gPacketReceived == PACKET_RECEIVED)
		{
			/* f[^fR[h&XgXV or o^ */
			UC aSPIError = Main_decodeMain(gReceivePacket);
			
			/* Mf[^ij */
			switch( aSPIError)
			{
				/**/
				case 0x00: 
					Main_sendReplyPacket(CMD_OK);
					break;
				/* w߂҂Ă */
				case 0x01:
					Main_sendReplyPacket(CMD_WAIT);
					break;
				/* R}hvȂ */			
				case 0xFE:
					Main_sendReplyPacket(CMD_CMDERR);
					/* G[v_ */
					DS_LEDERR(1);
					break;
				/* CRCvȂ */
				case 0xFF:
					Main_sendReplyPacket(CMD_CRCERR);
					/* G[v_ */
					DS_LEDERR(1);					
					break;
				/* s̃G[ */
				default:
					Main_sendReplyPacket(CMD_UNKERR);
					/* G[v_ */
					DS_LEDERR(1);
					break;				
			}
			
			/* pPbgMtÕZbg */
			gPacketReceived = PACKET_NOTRECEIVED;
		}
	
		
		/* Xg̃XL */
		if( MAIN_scanList(gList, gScanIndex) != 255)
		{
			/* ̃pPbg */
			gScanIndex++;
		}
		else
		{
			/* Zbg */
			gScanIndex = 0;
		}
							
    }
}




void init()
{
	SPI_Init();
	
	/* LED */
	DDRC =  (1<<DDC0)|(1<<DDC1)|(1<<DDC2);
	PORTC = 0b00000111;
	
	/* Q[gM */
	DDRD =  (1<<DDD6)|(1<<DDD5);
	PORTD = 0b00011100;	/* INT0, INT1, PCINT20̃vAbvON */
	
	/* OINT */
	EICRA = 0b0010;
	EIMSK = 0b01;
	
	/* PCINT0(SPI SS̘_ω) */
	PCMSK0 = 0b00000100;
	PCICR = 0b101;
	
	/* PCINT20(RESTART̘_ω) */
	PCMSK2 = 0b00010000;

	/* LED_RUN ON */
	DS_LEDRUN(0);
			
	/* G[v */
	DS_LEDERR(0);
	
}

void SPI_Init()
{

	// MISOo͂
	DDR_SPI |= (1<<4);
	//MOSI,SCK,SS͂
	DDR_SPI &= 0xff - (1<<3) - (1<<2) - (1<<5);

	SPCR = 0b11100011;//SPI mode0(CPOL=0,CPHA=0,SLAVE,SPIenable,SPIIRWenable,,
	SPSR = 0b00000000;//{

}

void TIMER2_start(void)
{
	TIMER2_stop(); //stop
	TCNT1 = 0x00; //set count
	TCCR1A = 0b0; 
	TCCR1B = 0b0101; //start timer 111=clkT2S/1024 (1024)
}

void TIMER2_stop(void)
{
	TCCR1B = 0x00; //stop
	TCNT1 = 0x00; //set count
	TCCR1A = 0b0;
	TCCR1B = 0b0101; //start timer 111=clkT2S/1024 (1024)
}

US TIMER2_getcnt(void)
{
	return TCNT1;
}

ISR(SPI_STC_vect){			/* f[^͂ƂSPIFƂ̊݃[` */

	if( gPacketCount < 7)
	{
		//̒ʐMőf[^Zbg
		SPDR = gSendPacket[gPacketCount];
	}
	
	//̒ʐMŎMf[^
	gReceivePacket[gPacketCount] = SPDR;	//PoCg荞

	gPacketCount++;


}

/* Emergency{^ꂽƂ̏ip[Itj */
ISR(INT0_vect)
{
	/* `^Oh~ */
	_delay_ms(10);
	
	/* Ml`FbN */
	if( bit_is_clear(PIND, PD2) )
	{		
		
		/* ً}~Ƃ */
		DS_GateOff();
		
		/* Arduinoɂ̓It̂Ƃ𑗐M */
		Main_sendReplyPacket(CMD_PWR_OFF);
	
	}
	else
	{
		/* Ƃ */
		
	}
	
}

ISR(PCINT0_vect)
{
	/* SPI SSM */
	
	if( bit_is_clear(PINB, PB2))
	{
		/* SS(ʐMJn) */
		gPacketCount = 0;
		
		/* pPbgMtO */
		gPacketReceived = PACKET_NOTRECEIVED;
	}
	else
	{
		/* SSiʐMIj */
		
		/* ƎMIĂ */
		if(gPacketCount > 0)
		{
			/* pPbgMtÕZbg */
			gPacketReceived = PACKET_RECEIVED;			
		}
	
		
	}	
}

ISR(PCINT2_vect)
{
	/* `^Oh~ */
	_delay_ms(10);
	
	if( bit_is_clear(PIND, PD4) && (gPoweronTrigger != TRIGGER_NONE))
	{
		/* X^[g */
		DS_Power(0);
		
		/* 1ms҂ */
		_delay_ms(1);
				
		/* Hɓd */
		DS_Power(1);
				
		/* fR[_̓d肷܂ő҂ */
		_delay_ms(10);
		
	}

	
}