/*
 * DS_Liste.c
 *
 * Created: 2014/08/10 5:54:29
 *  Author: Yaasan
 */ 


#include "DS_Type.h"
#include "DS_Common.h"
#include "DS_DCC.h"
#include "DS_MM2.h"
#include "DS_List.h"

UC gAliveChkCnt[ITEM_LISTSIZE]; /* mFJE^ */


UC DSList_AddItem(DS_ITEM *inList, DS_ITEM inItem)
{
	UC aNewItemNo = 0;
	
	/**/
	for( int i = 0; i < ITEM_LISTSIZE; i++)
	{
		
		if(inList[i].mType == 0)
		{
			aNewItemNo = i;
			break;
		}
	}
	
	/* o^ */
	return DSList_SetItem(inList, aNewItemNo, inItem);
	
}

DS_ITEM DSList_GetItem(DS_ITEM *inList, UC inNo)
{
	return inList[inNo];
}

UC DSList_SetItem(DS_ITEM *inList, UC inNo, DS_ITEM inItem)
{
	/* Zbg */
	inList[inNo].mType = inItem.mType;
	inList[inNo].mLen = inItem.mLen;
	inList[inNo].mNo = inItem.mNo;
	inList[inNo].mCnt = inItem.mCnt;
	inList[inNo].mIncCnt = inItem.mIncCnt;
	inList[inNo].mFunctionBuf = inItem.mFunctionBuf;
	inList[inNo].mDirection = inItem.mDirection;
	inList[inNo].mCmd = inItem.mCmd;
	inList[inNo].mFuncNo = inItem.mFuncNo;
	inList[inNo].mFuncCounter = inItem.mFuncCounter;
	inList[inNo].mSpeedStep = inItem.mSpeedStep;
	
	for( int i = 0; i < inItem.mLen; i++)
	{
		inList[inNo].mDatas[i] = inItem.mDatas[i];
	}
	
	return inNo;
	
}

UC DSList_NewItem(DS_ITEM *inList, UC inType, UC inCmd, UC inLen, UC inCnt, UC inDirection, UC *inDatas)
{
	DS_ITEM aItem;
	aItem.mType = inType;
	aItem.mLen = inLen;
	aItem.mCnt = inCnt;
	aItem.mCmd = inCmd;
	aItem.mIncCnt = 0;
	aItem.mFunctionBuf = 0;
	aItem.mDirection = inDirection;
	aItem.mFuncNo = 0;
	aItem.mFuncCounter = 0;
	aItem.mSpeedStep = 0;

	
	for( int i = 0; i < inLen; i++)
	{
		aItem.mDatas[i] = inDatas[i];
	}
	
	return DSList_AddItem(inList, aItem);
}

UC DSList_UpdateItem(DS_ITEM *inList, UC inType, UC inCmd, UC inLen, UC inCnt, UC *inDatas)
{
	
	UC aUpdatedIndex;

	aUpdatedIndex = DSList_FindItem(inList, inType, inLen, inCnt, inDatas);

	/* o^ĂȂ̂ŐVKo^ */
	if(aUpdatedIndex == 255)
	{
		return DSList_NewItem(inList, inType, inCmd, inLen, inCnt, DIR_FWD, inDatas);
	}
	
	/* R}h */
	inList[aUpdatedIndex].mCmd = inCmd;
	
	switch(inType)
	{
		case ITEMTYPE_MM2BASE:
		case ITEMTYPE_MM2HALF:
		inList[aUpdatedIndex].mDatas[0] = inDatas[0];
		inList[aUpdatedIndex].mDatas[1] = inDatas[1];
		inList[aUpdatedIndex].mDatas[2] = inDatas[2];
		break;
		
		case ITEMTYPE_DCC:
		/* f[^XV */
		for( int j = 0; j < 5; j++)
		{
			inList[aUpdatedIndex].mDatas[j] = inDatas[j];
		}
		break;
	}

	/* TCY͕ς邩Ȃ̂ōXV */
	inList[aUpdatedIndex].mLen = inLen;
	
	/* JE^ */
	inList[aUpdatedIndex].mIncCnt++;
	
	if(inList[aUpdatedIndex].mIncCnt >= 255)
	{
		inList[aUpdatedIndex].mIncCnt = 0;
	}
	
	return aUpdatedIndex;
	
}

UC DSList_FindItem(DS_ITEM *inList, UC inType, UC inLen, UC inCnt, UC *inDatas)
{
	UC aUpdatedIndex = 255;
	UC aChkAnd = 0;
	
	switch(inType)
	{
		case ITEMTYPE_MM2BASE:
		
		for( int i = 0; i < ITEM_LISTSIZE; i++)
		{
			if( (inList[i].mDatas[0] == inDatas[0]) && (inList[i].mType == inType))
			{
				aUpdatedIndex = i;
				break;
			}
		}
		break;
		
		case ITEMTYPE_MM2HALF:
		
		for( int i = 0; i < ITEM_LISTSIZE; i++)
		{
			if( (inList[i].mDatas[0] == inDatas[0]) && (inList[i].mType == inType) && ((inList[i].mDatas[2] & 0b1111) == (inDatas[2] & 0b1111)))
			{
				aUpdatedIndex = i;
				break;
			}
		}
		
		break;
		
		case ITEMTYPE_DCC:
		
		/* gAhX`FbN */
		if( ((inDatas[0] >> 7) & 0b1) == 0b1)
		{
			aChkAnd = 0xFF;
		}
		else
		{
			aChkAnd = 0x00;
		}
		
		for( int i = 0; i < ITEM_LISTSIZE; i++)
		{
			/* gAhX͊gAhX̑oCglă`FbN */
			if( (inList[i].mDatas[0] == inDatas[0]) && ((inList[i].mDatas[1] & aChkAnd) == (inDatas[1] & aChkAnd)) && (inList[i].mType == inType))
			{
				aUpdatedIndex = i;
				break;
			}
		}
		
		break;
	}

	return aUpdatedIndex;
	
}


UC DSList_UpdateItem_OWFunction(DS_ITEM *inList, UC inType, UC inCmd, UC inLen, UL inFuncBuf, UC inFuncNo, UC *inDatas)
{
	UC aUpdatedIndex;

	aUpdatedIndex = DSList_FindItem(inList, inType, inLen, 0, inDatas);

	/* o^ĂȂ̂ŐVKo^ */
	if(aUpdatedIndex == 255)
	{
		aUpdatedIndex = DSList_NewItem(inList, inType, inCmd, inLen, 0, DIR_FWD, inDatas);
	}
	
	switch(inType)
	{
		case ITEMTYPE_MM2BASE:
		/* MM2ł̓t@NV͎XLōŝŁAAhXExEpPbg͈؍XVȂ */
		inList[aUpdatedIndex].mFunctionBuf = inFuncBuf;
		inList[aUpdatedIndex].mFuncNo = inFuncNo;	//t@NVԍ̃Zbg
		inList[aUpdatedIndex].mFuncCounter = 4; // 4At@NVM𑗂
		/* R}h */
		inList[aUpdatedIndex].mCmd = inCmd;
		
		break;
		
		case ITEMTYPE_DCC:
		
		/* f[^XV */
		for( int j = 0; j < 5; j++)
		{
			inList[aUpdatedIndex].mDatas[j] = inDatas[j];
		}
		
		/* t@NVobt@ */
		inList[aUpdatedIndex].mFunctionBuf = inFuncBuf;
		/* R}h */
		inList[aUpdatedIndex].mCmd = inCmd;
		
		/* TCY͕ς邩Ȃ̂ōXV */
		inList[aUpdatedIndex].mLen = inLen;
		
		break;
		
	}
	
	
	/* JE^ */
	inList[aUpdatedIndex].mIncCnt++;
	
	if(inList[aUpdatedIndex].mIncCnt >= 255)
	{
		inList[aUpdatedIndex].mIncCnt = 0;
	}
	
	return aUpdatedIndex;

}

UC DSList_DeleteItem(DS_ITEM *inList, UC inNo)
{
	DSList_ZeroItem(inList, inNo);
	DSList_ShiftItem(inList, inNo);
	
	return inNo;
}

UC DSList_ZeroItem(DS_ITEM *inList, UC inNo)
{
	/* Zbg */
	inList[inNo].mType = ITEMTYPE_UNKNOWN;
	inList[inNo].mLen = 0;
	inList[inNo].mNo = 0;
	inList[inNo].mCnt = 0;
	inList[inNo].mIncCnt = 0;
	inList[inNo].mFunctionBuf = 0;
	inList[inNo].mDirection = DIR_FWD;
	inList[inNo].mCmd = 0;
	inList[inNo].mFuncNo = 0;
	inList[inNo].mFuncCounter = 0;
	inList[inNo].mSpeedStep = 0;
	
	for( int i = 0; i < 5; i++)
	{
		inList[inNo].mDatas[i] = 0;
	}
	
	return inNo;
	
}

UC DSList_ShiftItem(DS_ITEM *inList, UC inNo)
{
	
	for( int i = inNo; i < ITEM_LISTSIZE - 1; i++)
	{
		if( inList[i + 1].mType != ITEMTYPE_UNKNOWN )
		{
			DSList_SetItem(inList, i, inList[i + 1]);
		}
		else
		{
			DSList_ZeroItem(inList, i);
			break;
		}
	}
	
	return inNo;
}

void DSList_Clear(DS_ITEM *inList)
{
	
	for( int i = 0; i < ITEM_LISTSIZE; i++)
	{
		DSList_ZeroItem(inList, i);
	}
	
}


void DSList_Maintainance(DS_ITEM *inList)
{
	UC aNewItemNo = 0;
	
	/* Xg̓o^擾 */
	for( int i = 0; i < ITEM_LISTSIZE; i++)
	{
		
		if(inList[i].mType == 0)
		{
			aNewItemNo = i;
			break;
		}
	}
	
	/* Xg10ȏソ܂AeiXJn */
	if( aNewItemNo > 10 )
	{
		/* O(bO)ƕω܂薳͍̂폜*/
		for(int i = 0; i < ITEM_LISTSIZE; i++ )
		{
			if( gAliveChkCnt[i] == inList[i].mIncCnt )
			{
				/*ω̂ō폜*/
				DSList_DeleteItem(inList, i);
				break;
			}
		}
		
		/* OlXgɃRs[ */
		for(int i = 0; i < ITEM_LISTSIZE; i++ )
		{
			gAliveChkCnt[i] = inList[i].mIncCnt;
		}
	}
	
}